require("Game_Object")

function new_bullet(game_area, start_pos, velocity)
	local base = new_game_object(game_area)
	
	return
		game_object_extend(base,
		{
			-- Type of game object
			type = "bullet",
			
			-- Position for the game object
			pos = start_pos,
			
			-- Render mesh (for default render behavior)
			render_mesh = "ball",
			-- Render material
			render_mat = new_material("material_bullet"),
			-- Render shader args
			render_args = { color = vec4(1,2,3,1) },
			
			-- Collision radius
			col_radius = 0.5,

			vel = velocity,
			age = 0,
			alive = true,
			
			-- Returns the current rendering matrix
			get_render_matrix = function(this)
				return mat4_translation(this.pos) * mat4_scale(this.col_radius)
				end,
			
			-- Updates the object
			update = function(this, delta_t)
				this.pos = this.pos + this.vel * delta_t
				this.age = this.age + delta_t
				return this.alive and (this.age < 1)
				end,
				
			-- Called on collision
			on_collision = function(this, oth_obj)
				if oth_obj.type == "player" or
				   oth_obj.type == "bullet" then
					return
				end
				
				this.alive = false
				end,
		})
end
