require("Material")
require("Renderer")
require("Screen_Game")

function new_screen_menu()
	-- Start the music
	audio_play_stream("Data/Audio/music_menu.ogg")
	
	return
		{
			renderer = new_renderer(),

			bg_material = new_material("material_menu_bg"),
			
			angle = 0,
			mouse_down = false,
			
			update = function(this, delta_t)
				-- Rotate the background
				this.angle = this.angle + delta_t * 0.1
				
				-- Handle the mouse
				local mouse_x, mouse_y, mouse_b1, mouse_b2 = mouse_read()
				
				local prev_mouse = this.mouse_down
				this.mouse_down = mouse_b1
				
				if prev_mouse and not mouse_b1 then
					return new_screen_game()
				end
				
				return this
				end,
				
			render = function(this)
				local cam_pos = vec3(0, 1, -0.3) * 3.7
				local cam_mtx = mat4_target_at(cam_pos, vec3(0,0,0), vec3_unit(vec3(0,1,0)))

				this.renderer:new_frame()
				this.renderer:set_camera(cam_mtx)
				
				local b = 2
				this.bg_material:set_shader_value("color", vec4(0.3*b, 0.1*b, 0.05*b, 1))
				this.renderer:add_mesh("menu_background", mat4_rot_xyz(0, this.angle, math.sin(this.angle * 0.4) * 0.2), this.bg_material)
				
				this.renderer:add_text("G I N O M O U S", -120, 100, 2)
				this.renderer:add_text("Press left mouse button to start", -127, -100, 1)
				this.renderer:add_text("Press ESC or ALT-F4 to quit", -110, -110, 1)
				this.renderer:add_text("http://www.xmunkki.org/", -140, -140, 0.5)
				this.renderer:add_text("v2", -140, -145, 0.2)
				this.renderer:add_text("M - Mute/unmute", 80, -140, 0.5)
				
				this.renderer:render()
				end,
		}
end
